{ Tests exception handling in the Win32 subsystem of WDOSX. Especially FPU 
  exceptions are hard to deal with but finally I think I got it right. See
  it for yourself! }

uses sysutils; { Yeah, now we can do that! Wasn't possible in WDOSX 0.93. }

type
    ex = class(Exception);

var a,b: double;
    i,j: integer;
    p: Pchar;
    f: file;

begin
   { generate an integer divide overflow }
   i:=5;
   j:=0;
   try
     writeln(i div j);
   except
     on e: Exception do begin 
       writeln(e.Message);
     end;
   end;
   { now do the same for floating point numbers }
   a:=5.0;
   b:=0.0;
   try
     writeln(a/b);
   except
     on e: Exception do begin 
       writeln(e.Message);
     end;
   end;
   { generate a page fault, note that the aditional information in e.Message
     is bogus since there is no way to read the linear address from cr2 in
     a multitasking environment }
   try
     for i:=0 to $fffff do j:=j+ord(p[i*$1000]);
   except
     on e: Exception do begin 
       writeln(e.Message);
       writeln('This has been a page fault after ',i,' iterations.');
       writeln('If we did not use j the optimizer would throw away the loop code: ',j);
     end;
   end;
   { generate a GPF, in true Win32 this is likely to become a page fault too }
   try
     asm
       mov cs:[0],al
     end;
   except
     on e: Exception do begin 
       writeln(e.Message);
       writeln('Never write to code segments!');
     end;
   end;
   { generate a non-cpu exception }
   try
     assign(f,'!&%$%.$&&');
     reset(f);
   except
     on e: Exception do begin 
       writeln(e.Message);
     end;
   end;
   { raise a custom exception }
   try
     raise ex.Create('Custom Exception');
   except
     on e: Exception do begin 
       writeln(e.Message);
     end;
   end;
   writeln('Still running');
end.
